org.apache.solr.core

## Interface CoresLocator

- All Known Implementing Classes:
    CorePropertiesLocator

      public interface CoresLocator

  Manage the discovery and persistence of core definitions across Solr restarts

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `create(CoreContainer cc, CoreDescriptor... coreDescriptors)` Make new cores available for discovery
    `void` | `delete(CoreContainer cc, CoreDescriptor... coreDescriptors)` Ensure that the core definitions from the passed in CoreDescriptors are not available for discovery
    `List<CoreDescriptor>` | `discover(CoreContainer cc)` Load all the CoreDescriptors from persistence store
    `void` | `persist(CoreContainer cc, CoreDescriptor... coreDescriptors)` Ensure that the core definitions from the passed in CoreDescriptors will persist across container restarts.
    `void` | `rename(CoreContainer cc, CoreDescriptor oldCD, CoreDescriptor newCD)` Persist the new name of a renamed core
    `void` | `swap(CoreContainer cc, CoreDescriptor cd1, CoreDescriptor cd2)` Swap two core definitions

- - ### Method Detail

    - #### create

          void create(CoreContainer cc,
                      CoreDescriptor... coreDescriptors)

      Make new cores available for discovery
      Parameters:
        `cc` - the CoreContainer
        `coreDescriptors` - CoreDescriptors to persist

    - #### persist

          void persist(CoreContainer cc,
                       CoreDescriptor... coreDescriptors)

      Ensure that the core definitions from the passed in CoreDescriptors will persist across container restarts.
      Parameters:
        `cc` - the CoreContainer
        `coreDescriptors` - CoreDescriptors to persist

    - #### delete

          void delete(CoreContainer cc,
                      CoreDescriptor... coreDescriptors)

      Ensure that the core definitions from the passed in CoreDescriptors are not available for discovery
      Parameters:
        `cc` - the CoreContainer
        `coreDescriptors` - CoreDescriptors of the cores to remove

    - #### rename

          void rename(CoreContainer cc,
                      CoreDescriptor oldCD,
                      CoreDescriptor newCD)

      Persist the new name of a renamed core
      Parameters:
        `cc` - the CoreContainer
        `oldCD` - the CoreDescriptor of the core before renaming
        `newCD` - the CoreDescriptor of the core after renaming

    - #### swap

          void swap(CoreContainer cc,
                    CoreDescriptor cd1,
                    CoreDescriptor cd2)

      Swap two core definitions
      Parameters:
        `cc` - the CoreContainer
        `cd1` - the core descriptor of the first core, after swapping
        `cd2` - the core descriptor of the second core, after swapping

    - #### discover

          List<CoreDescriptor> discover(CoreContainer cc)

      Load all the CoreDescriptors from persistence store
      Parameters:
        `cc` - the CoreContainer
      Returns:
        a list of all CoreDescriptors found

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.